/*
 * This file is generated by jOOQ.
 */
package ajar.ieds.calc.api.sql.tables.daos;


import ajar.ieds.calc.api.sql.tables.Expression;
import ajar.ieds.calc.api.sql.tables.pojos.JooqExpression;
import ajar.ieds.calc.api.sql.tables.records.ExpressionRecord;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Optional;

import javax.annotation.processing.Generated;

import org.jooq.Configuration;
import org.jooq.impl.DAOImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.18.4",
        "schema version:1"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
@Repository
public class ExpressionRepository extends DAOImpl<ExpressionRecord, JooqExpression, Long> {

    /**
     * Create a new ExpressionRepository without any configuration
     */
    public ExpressionRepository() {
        super(Expression.EXPRESSION, JooqExpression.class);
    }

    /**
     * Create a new ExpressionRepository with an attached configuration
     */
    @Autowired
    public ExpressionRepository(Configuration configuration) {
        super(Expression.EXPRESSION, JooqExpression.class, configuration);
    }

    @Override
    public Long getId(JooqExpression object) {
        return object.getExpressionId();
    }

    /**
     * Fetch records that have <code>expression_id BETWEEN lowerInclusive AND
     * upperInclusive</code>
     */
    public List<JooqExpression> fetchRangeOfExpressionId(Long lowerInclusive, Long upperInclusive) {
        return fetchRange(Expression.EXPRESSION.EXPRESSION_ID, lowerInclusive, upperInclusive);
    }

    /**
     * Fetch records that have <code>expression_id IN (values)</code>
     */
    public List<JooqExpression> fetchByExpressionId(Long... values) {
        return fetch(Expression.EXPRESSION.EXPRESSION_ID, values);
    }

    /**
     * Fetch a unique record that has <code>expression_id = value</code>
     */
    public JooqExpression fetchOneByExpressionId(Long value) {
        return fetchOne(Expression.EXPRESSION.EXPRESSION_ID, value);
    }

    /**
     * Fetch a unique record that has <code>expression_id = value</code>
     */
    public Optional<JooqExpression> fetchOptionalByExpressionId(Long value) {
        return fetchOptional(Expression.EXPRESSION.EXPRESSION_ID, value);
    }

    /**
     * Fetch records that have <code>name BETWEEN lowerInclusive AND
     * upperInclusive</code>
     */
    public List<JooqExpression> fetchRangeOfName(String lowerInclusive, String upperInclusive) {
        return fetchRange(Expression.EXPRESSION.NAME, lowerInclusive, upperInclusive);
    }

    /**
     * Fetch records that have <code>name IN (values)</code>
     */
    public List<JooqExpression> fetchByName(String... values) {
        return fetch(Expression.EXPRESSION.NAME, values);
    }

    /**
     * Fetch records that have <code>expression BETWEEN lowerInclusive AND
     * upperInclusive</code>
     */
    public List<JooqExpression> fetchRangeOfExpression(String lowerInclusive, String upperInclusive) {
        return fetchRange(Expression.EXPRESSION.EXPRESSION_, lowerInclusive, upperInclusive);
    }

    /**
     * Fetch records that have <code>expression IN (values)</code>
     */
    public List<JooqExpression> fetchByExpression(String... values) {
        return fetch(Expression.EXPRESSION.EXPRESSION_, values);
    }

    /**
     * Fetch records that have <code>created_at BETWEEN lowerInclusive AND
     * upperInclusive</code>
     */
    public List<JooqExpression> fetchRangeOfCreatedAt(LocalDateTime lowerInclusive, LocalDateTime upperInclusive) {
        return fetchRange(Expression.EXPRESSION.CREATED_AT, lowerInclusive, upperInclusive);
    }

    /**
     * Fetch records that have <code>created_at IN (values)</code>
     */
    public List<JooqExpression> fetchByCreatedAt(LocalDateTime... values) {
        return fetch(Expression.EXPRESSION.CREATED_AT, values);
    }

    /**
     * Fetch records that have <code>modified_at BETWEEN lowerInclusive AND
     * upperInclusive</code>
     */
    public List<JooqExpression> fetchRangeOfModifiedAt(LocalDateTime lowerInclusive, LocalDateTime upperInclusive) {
        return fetchRange(Expression.EXPRESSION.MODIFIED_AT, lowerInclusive, upperInclusive);
    }

    /**
     * Fetch records that have <code>modified_at IN (values)</code>
     */
    public List<JooqExpression> fetchByModifiedAt(LocalDateTime... values) {
        return fetch(Expression.EXPRESSION.MODIFIED_AT, values);
    }

    /**
     * Fetch records that have <code>author BETWEEN lowerInclusive AND
     * upperInclusive</code>
     */
    public List<JooqExpression> fetchRangeOfAuthor(String lowerInclusive, String upperInclusive) {
        return fetchRange(Expression.EXPRESSION.AUTHOR, lowerInclusive, upperInclusive);
    }

    /**
     * Fetch records that have <code>author IN (values)</code>
     */
    public List<JooqExpression> fetchByAuthor(String... values) {
        return fetch(Expression.EXPRESSION.AUTHOR, values);
    }
}
